import * as genericLayer from '../genericLayer'
import {testingLayerCallerName} from '../../constants'
import {
  GetSqlCheckerStatusCommandForBackend,
  GetSqlCheckerStatusResponseFromBackend,
  RunTestCommandForBackend,
  TestAnswerFromBackend
} from '../../types/testsAndTestProtocol'


export const callingName = testingLayerCallerName
const controllerPrefix = 'thirdpartysqlchecker'


/**
 * runs a test on the test server (through the backend)
 */
export async function runSqlCheckerTest(runNormalTestCommand: RunTestCommandForBackend): Promise<ReadonlyArray<TestAnswerFromBackend>> {

  return await genericLayer.update<RunTestCommandForBackend, ReadonlyArray<TestAnswerFromBackend>>(
    callingName,
    `${controllerPrefix}/run`, runNormalTestCommand
  )
}

export async function getSqlCheckerTestStatus(getSqlCheckerStatusCommand: GetSqlCheckerStatusCommandForBackend): Promise<ReadonlyArray<GetSqlCheckerStatusResponseFromBackend>> {

  return await genericLayer.update<GetSqlCheckerStatusCommandForBackend, ReadonlyArray<GetSqlCheckerStatusResponseFromBackend>>(
    callingName,
    `${controllerPrefix}/status`, getSqlCheckerStatusCommand
  )
}
