import {RunnableExerciseTestFrontendExclusive} from '../types/exerciseEditor'


/**
 * checks if a test is currently submitted and pending on the sql checker (we don't have a valid result back yet)
 * @param test
 */
export function isSqlCheckerTestResultPending(test: RunnableExerciseTestFrontendExclusive): boolean {

  //not yet submitted
  if (test.result === null || test.result.programExitCode === null) return false

  //we got a result and a submission id

  //do we already have result?? then it's not pending
  if (test.result.protocol.length === 1 && test.result.protocol[0] !== '') return false

  return true
}

