/**
 * Created by janis dähne.
 */
import {
  ResetAction,
  SET_isCreatingAction,
  SET_isHelpDisplayedAction, SET_selectedTabIndexAction
} from "../../../../reducers/exerciseEditorSite/dialogs/changeTestDialog/changeTestDialogReducer";
import {ActionType} from "../../../../reducers/exerciseEditorSite/dialogs/changeTestDialog/changeTestDialogActionTypes";
import {MultiActions} from "../../../types";
import {setEditingExerciseTest, setIsSubmitTest} from "./changeTestActions";
import {ExerciseTestForBackend} from "../../../../../types/exerciseEditor";
import {setIsChangeTestDialogDisplayed} from "../../exerciseEditorSiteActions";
import {setEditorTests} from "../../subSets/editorExerciseTestsActions";


export function setIsHelpDisplayedAction(isDisplayed: boolean): SET_isHelpDisplayedAction {
  return {
    type: ActionType.SET_isHelpDisplayed,
    isDisplayed
  }
}

export function setIsCreating(isCreating: boolean): SET_isCreatingAction {
  return {
    type: ActionType.SET_isCreating,
    isCreating
  }
}

export function setSelectedTabIndex(index: number): SET_selectedTabIndexAction {
  return {
    type: ActionType.SET_selectedTabIndex,
    index
  }
}


export function openCreateEditorTestDialog(isSubmitTest: boolean): MultiActions {
  return dispatch => {

    dispatch(resetChangeEditorTestDialog())
    dispatch(setIsCreating(true))
    dispatch(setIsSubmitTest(isSubmitTest))

    dispatch(setIsChangeTestDialogDisplayed(true))
  }
}

export function openEditEditorTestDialog(test: ExerciseTestForBackend): MultiActions {
  return dispatch => {

    dispatch(resetChangeEditorTestDialog())
    dispatch(setIsCreating(false))
    dispatch(setEditingExerciseTest(test))

    dispatch(setIsChangeTestDialogDisplayed(true))
  }
}

export function applyChangedEditorTestDialog(changedTest: ExerciseTestForBackend, isCreating: boolean,
                                             AllTest: ReadonlyArray<ExerciseTestForBackend>): MultiActions {
  return (dispatch) => {

    if (isCreating) {

      dispatch(setEditorTests(
        [...AllTest, {...changedTest}]
      ))

    } else {

      dispatch(setEditorTests(
        AllTest.map(p => {
          return p.id === changedTest.id ?
            {
              ...changedTest
            }
            : p
        })
      ))
    }


    dispatch(resetChangeEditorTestDialog())
    dispatch(setIsChangeTestDialogDisplayed(false))
  }
}

export function cancelEditorTestDialog(): MultiActions {
  return dispatch => {

    dispatch(resetChangeEditorTestDialog())
    dispatch(setIsChangeTestDialogDisplayed(false))
  }
}


export function resetChangeEditorTestDialog(): ResetAction {
  return {
    type: ActionType.RESET,
  }
}
