/**
 * Created by janis dähne.
 */


/**
 * a test type e.g. black box tests, compile test...
 */
export interface TestTypeFullBase {
  readonly id: number
  /**
   * the type display name
   */
  readonly displayName: string

  /**
   * the internal name
   */
  readonly internalName: string
}

/**
 * some known test types used to format something according to the test type...
 *
 * these are the internal names
 */
export enum KnownInternalTestTypes {

  blackBoxTest = 'blackBoxTest',
  compileTest = 'compileTest',
  regexTest = 'regexTest',
  /**
   * in this case the test content is
   * @see CompareFileTestContentFrontendOnly[]
   */
  compareFilesTest = 'compareFilesTest',
  //this is not part of the test types the user can Select an option...
  //so it is only added sometimes to just run the program e.g. console view needs this even if
  //the test type cannot be chosen by the user
  justRunTest = 'justRunTest',

  /**
   * integration for a third party sql checker
   * must match server constant IntegrationSqlCheckerTestInternalName
   */
  integrationSqlCheckerTestInternalName = 'integrationSqlCheckerTestInternalName'

}


